

Imports LabDB.DBSaber.StdTools

''' <summary>
''' Represents an Oligo thingy
''' </summary>
''' <remarks></remarks>
Public Class Oligo


#Region " Member Variables "

    Private m_OligoID As Integer
    Private m_LabName As String = ""
    Private m_RecDate As Date = Now
    Private m_FormerName As String = ""
    Private m_Purpose As String = ""
    Private m_Sequence As String = ""
    Private m_RestrictionSites As String = ""
    Private m_Gene As String = ""
    Private m_Speices As String = ""
    Private m_Position As String = ""
    Private m_Strand As String = ""
    Private m_Donor As String = ""
    Private m_StockConc As String = ""
    Private m_Supplier As String = ""
    Private m_Comments As String = ""
    Private m_LastModified As Date = Now

    Private m_CustomField1 As String = ""
    Private m_CustomField2 As String = ""

    Private m_Tm As Single

#End Region


    Public Const cTableName As String = "tblOligo"

    Public MatchCount As Integer
    Public MatchLongest As Integer
    Public MatchLongestIndex As String = ""


#Region " Construcors "

    Public Sub New()

        'Blank

    End Sub

    Public Sub New(ByRef rConn As Data.Common.DbConnection, ByVal vOligoID As Integer)

        Me.DBLoad(rConn, vOligoID)

    End Sub

    Public Sub New(ByRef rRS As Data.Common.DbDataReader)

        Me.RSLoad(rRS)

    End Sub

#End Region



#Region " Properties "

    Public Property OligoID() As Integer
        Get
            Return Me.m_OligoID
        End Get
        Set(ByVal value As Integer)
            Me.m_OligoID = value
        End Set
    End Property

    Public Property LabName() As String
        Get

            Return Me.m_LabName

        End Get
        Set(ByVal value As String)
            Me.m_LabName = value
        End Set
    End Property

    Public Property RecDate() As Date
        Get
            Return Me.m_RecDate
        End Get
        Set(ByVal value As Date)
            Me.m_RecDate = value
        End Set
    End Property

    Public Property FormerName() As String
        Get
            Return Me.m_FormerName
        End Get
        Set(ByVal value As String)
            Me.m_FormerName = value
        End Set
    End Property

    Public Property Purpose() As String
        Get
            Return Me.m_Purpose
        End Get
        Set(ByVal value As String)
            Me.m_Purpose = value
        End Set
    End Property

    Public Property Sequnce() As String
        Get
            Return Me.m_Sequence
        End Get
        Set(ByVal value As String)
            Me.m_Sequence = value
        End Set
    End Property

    Public Property RestrictionSite() As String
        Get
            Return Me.m_RestrictionSites
        End Get
        Set(ByVal value As String)
            Me.m_RestrictionSites = value
        End Set
    End Property

    Public Property Gene() As String
        Get
            Return Me.m_Gene
        End Get
        Set(ByVal value As String)
            Me.m_Gene = value
        End Set
    End Property

    Public Property Speices() As String
        Get
            Return Me.m_Speices
        End Get
        Set(ByVal value As String)
            Me.m_Speices = value
        End Set
    End Property

    Public Property Position() As String
        Get
            Return Me.m_Position
        End Get
        Set(ByVal value As String)
            Me.m_Position = value
        End Set
    End Property

    Public Property Strand() As String
        Get
            Return Me.m_Strand
        End Get
        Set(ByVal value As String)
            Me.m_Strand = value
        End Set
    End Property

    Public Property Donor() As String
        Get
            Return Me.m_Donor
        End Get
        Set(ByVal value As String)
            Me.m_Donor = value
        End Set
    End Property

    Public Property StockConc() As String
        Get
            Return Me.m_StockConc
        End Get
        Set(ByVal value As String)
            Me.m_StockConc = value
        End Set
    End Property

    Public Property Supplier() As String
        Get
            Return Me.m_Supplier
        End Get
        Set(ByVal value As String)
            Me.m_Supplier = value
        End Set
    End Property

    Public Property Comments() As String
        Get
            Return Me.m_Comments
        End Get
        Set(ByVal value As String)
            Me.m_Comments = value
        End Set
    End Property

    Public ReadOnly Property SequenceLength() As Integer
        Get
            Return Me.Sequnce.Length
        End Get
    End Property

    Public ReadOnly Property LastModified() As Date
        Get
            Return Me.m_LastModified
        End Get
    End Property

    Public ReadOnly Property FullName() As String
        Get
            Return Me.LabName & "-" & String.Format("{0:00000}", Me.OligoID)
        End Get
    End Property


    Public Property CustomField1() As String
        Get
            Return Me.m_CustomField1
        End Get
        Set(ByVal value As String)
            Me.m_CustomField1 = value
        End Set
    End Property

    Public Property CustomField2() As String
        Get
            Return Me.m_CustomField2
        End Get
        Set(ByVal value As String)
            Me.m_CustomField2 = value
        End Set
    End Property

    Public Property Tm() As Single
        Get
            Return Me.m_Tm
        End Get
        Set(ByVal value As Single)
            Me.m_Tm = value
        End Set
    End Property

#End Region


#Region " Database Support "


    Public Sub DBLoad(ByRef rConn As Data.Common.DbConnection, ByVal vOligoID As Integer)

        Dim RS As Data.Common.DbDataReader
        Dim Cmd As Data.Common.DbCommand = rConn.CreateCommand


        Cmd.CommandText = "SELECT * FROM " & cTableName & " WHERE OligoID=@pOligoID"
        CommandParamAdd(Cmd, "pOligoID", DbType.Int32, vOligoID)

        RS = Cmd.ExecuteReader


        If RS.HasRows = True Then
            RS.Read()
            Me.RSLoad(RS)
            RS.Close()
        Else
            'Couldn't find it in the table
            Throw New DBSaber.NoRecordFoundDBException(cTableName, "OligoID", vOligoID)
            RS.Close()
        End If


    End Sub

    Public Sub RSLoad(ByRef rRS As Data.Common.DbDataReader)

        Me.m_OligoID = rRS.GetInt32(0)
        Me.m_LabName = DBValStr(rRS, 1)
        Me.m_RecDate = DBValDate(rRS, 2)  'rRS.GetDateTime(2)
        Me.m_FormerName = DBValStr(rRS, 3)
        Me.m_Purpose = DBValStr(rRS, 4)
        Me.m_Sequence = DBValStr(rRS, 5)
        Me.m_RestrictionSites = DBValStr(rRS, 6)
        Me.m_Gene = DBValStr(rRS, 7)
        Me.m_Speices = DBValStr(rRS, 8)
        Me.m_Position = DBValStr(rRS, 9)
        Me.m_Strand = DBValStr(rRS, 10)
        Me.m_Donor = DBValStr(rRS, 11)
        Me.m_StockConc = DBValStr(rRS, 12)
        Me.m_Supplier = DBValStr(rRS, 13)
        Me.m_Comments = DBValStr(rRS, 14)
        Me.m_LastModified = DBValDate(rRS, 15)
        Me.m_CustomField1 = DBValStr(rRS, 16)
        Me.m_CustomField2 = DBValStr(rRS, 17)

        Me.m_Tm = DBSaber.StdTools.DBValDec(rRS, 18)


    End Sub

    Public Sub DBSave(ByRef rConn As OleDb.OleDbConnection)


        Dim SQL As String
        'Dim DR As Data.Common.DbDataReader
        Dim Cmd As OleDb.OleDbCommand = rConn.CreateCommand


        If Me.OligoID = 0 Then

            Me.m_LastModified = Now


            'Insert

            SQL = "INSERT INTO " & cTableName & " (LabName, RecDate, FormerName, Purpose, Sequence, RestrictionSites, Gene, Species, PositionOf, Strand, Donor, StockConc, Supplier, Comments, LastModified, CustomField1, CustomField2, Tm) VALUES ("
            SQL = SQL & "@pLabName, @pRecDate, @pFormerName, @pPurpose, @pSequence, @pRestrictionSites, @pGene, @pSpecies, @pPositionOf, @pStrand, @pDonor, @pStockConc, @pSupplier, @pComments, @pLastModified, @pCustomField1, @pCustomField2, @Tm)"


            'SQL = SQL & "; " & vbCrLf & " SELECT @@IDENTITY AS NewOligoID"


            Cmd.CommandText = SQL


            CommandParamAdd(Cmd, "pLabName", DbType.String, Me.LabName)
            CommandParamAdd(Cmd, "pRecDate", DbType.String, Me.RecDate)
            CommandParamAdd(Cmd, "pFormerName", DbType.String, Me.FormerName)
            CommandParamAdd(Cmd, "pPurpose", DbType.String, Me.Purpose)
            CommandParamAdd(Cmd, "pSequence", DbType.String, Me.Sequnce)
            CommandParamAdd(Cmd, "pRestrictionSites", DbType.String, Me.RestrictionSite)
            CommandParamAdd(Cmd, "pGene", DbType.String, Me.Gene)
            CommandParamAdd(Cmd, "pSpecies", DbType.String, Me.Speices)
            CommandParamAdd(Cmd, "pPositionOf", DbType.String, Me.Position)
            CommandParamAdd(Cmd, "pStrand", DbType.String, Me.Strand)
            CommandParamAdd(Cmd, "pDonor", DbType.String, Me.Donor)
            CommandParamAdd(Cmd, "pStockConc", DbType.String, Me.StockConc)
            CommandParamAdd(Cmd, "pSupplier", DbType.String, Me.Supplier)
            CommandParamAdd(Cmd, "pComments", DbType.String, Me.Comments)
            CommandParamAdd(Cmd, "pLastModified", DbType.String, Me.m_LastModified)
            CommandParamAdd(Cmd, "pCustomField1", DbType.String, Me.CustomField1)
            CommandParamAdd(Cmd, "pCustomField2", DbType.String, Me.CustomField2)
            CommandParamAdd(Cmd, "pTm", DbType.Decimal, Me.Tm)

            Cmd.ExecuteNonQuery()



            Me.OligoID = DBSaber.StdTools.DBValue(rConn, "SELECT OligoID FROM " & cTableName & " WHERE LastModified=@pLastModified", "@pLastModified", DbType.String, Me.LastModified)





        Else
            'Update

            Me.m_LastModified = Now

            SQL = "UPDATE " & cTableName & " SET LabName=@pLabName, RecDate=@pRecDate"
            SQL = SQL & ",FormerName=@pFormerName, Purpose=@pPurpose, Sequence=@pSequence, RestrictionSites=@pRestrictionSites"
            SQL = SQL & ",Gene=@pGene, Species=@pSpecies, PositionOf=@pPositionOf, Strand=@pStrand"
            SQL = SQL & ", Donor=@pDonor, StockConc=@pStockConc, Supplier=@pSupplier, Comments=@pComments, LastModified=@pLastModified"
            SQL = SQL & ", CustomField1=@pCustomField1, CustomField2=@pCustomField2"
            SQL = SQL & ", Tm=@pTm"
            SQL = SQL & " WHERE OligoID=@pOligoID"


            Cmd.CommandText = SQL


            CommandParamAdd(Cmd, "pLabName", DbType.String, Me.LabName)
            CommandParamAdd(Cmd, "pRecDate", DbType.DateTime, Me.RecDate)

            CommandParamAdd(Cmd, "pFormerName", DbType.String, Me.FormerName)
            CommandParamAdd(Cmd, "pPurpose", DbType.String, Me.Purpose)
            CommandParamAdd(Cmd, "pSequence", DbType.String, Me.Sequnce)
            CommandParamAdd(Cmd, "pRestrictionSites", DbType.String, Me.RestrictionSite)

            CommandParamAdd(Cmd, "pGene", DbType.String, Me.Gene)
            CommandParamAdd(Cmd, "pSpecies", DbType.String, Me.Speices)
            CommandParamAdd(Cmd, "pPositionOf", DbType.String, Me.Position)
            CommandParamAdd(Cmd, "pStrand", DbType.String, Me.Strand)

            CommandParamAdd(Cmd, "pDonor", DbType.String, Me.Donor)
            CommandParamAdd(Cmd, "pStockConc", DbType.String, Me.StockConc)
            CommandParamAdd(Cmd, "pSupplier", DbType.String, Me.Supplier)
            CommandParamAdd(Cmd, "pComments", DbType.String, Me.Comments)

            CommandParamAdd(Cmd, "pLastModified", DbType.String, Me.LastModified)
            CommandParamAdd(Cmd, "pCustomField1", DbType.String, Me.CustomField1)
            CommandParamAdd(Cmd, "pCustomField2", DbType.String, Me.CustomField2)
            CommandParamAdd(Cmd, "pTm", DbType.Decimal, Me.Tm)

            CommandParamAdd(Cmd, "pOligoId", DbType.Int32, Me.OligoID)


            Cmd.ExecuteNonQuery()



        End If


    End Sub


    Public Shared Function DBOligos(ByRef rConn As Data.Common.DbConnection) As Generic.List(Of Oligo)

        Dim Cmd As Data.Common.DbCommand = rConn.CreateCommand
        Dim RS As Data.Common.DbDataReader
        Dim tCollect As New Generic.List(Of Oligo)

        Cmd.CommandText = "SELECT * FROM " & cTableName & " ORDER BY OligoID"


        RS = Cmd.ExecuteReader

        Do While RS.Read
            tCollect.Add(New Oligo(RS))
        Loop

        RS.Close()


        Return tCollect


    End Function


    ''' <summary>
    ''' Returns a list of all the query items
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function DBQItems() As Generic.List(Of SQLQueryItem)

        Dim tCollect As New Generic.List(Of SQLQueryItem)

        tCollect.Add(New SQLQueryItem("Oligo ID", "OligoID", DbType.Int32, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Lab Name", "LabName", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Record Date", "RecDate", DbType.Date, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Purpose", "Purpose", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Former Name", "FormerName", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))

        tCollect.Add(New SQLQueryItem("Restriction Sites", "RestrictionSites", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Gene", "Gene", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Species", "Species", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Position", "PositionOf", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))


        'tCollect.Add(New SQLQueryItem("Sequence", "Sequence", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))

        'tCollect.Add(New SQLQueryItem("Position", "Position", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Strand", "Strand", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Donor", "Donor", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Stock Conc.", "StockConc", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Supplier", "Supplier", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Comments", "Comments", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))

        tCollect.Add(New SQLQueryItem("Custom Field 1", "CustomField1", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Custom Field 2", "CustomField2", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))



        Return tCollect


    End Function

    ''' <summary>
    ''' Removes a record from the database
    ''' </summary>
    ''' <param name="rConn"></param>
    ''' <param name="vOligoID"></param>
    ''' <remarks></remarks>
    Public Shared Sub DBDelete(ByRef rConn As Data.Common.DbConnection, ByVal vOligoID As Integer)

        Dim Cmd As Data.Common.DbCommand = rConn.CreateCommand

        Cmd.CommandText = "DELETE FROM " & cTableName & " WHERE OligoID=@pOligoID"

        CommandParamAdd(Cmd, "pOligoID", DbType.Int32, vOligoID)

        Cmd.ExecuteNonQuery()

    End Sub

    'Purpose:
    Public Shared Function DBNextOligoID(ByRef rconn As Data.Common.DbConnection) As Integer


        Const cDefID As Integer = 1
        Dim DR As Data.Common.DbDataReader
        Dim Cmd As Data.Common.DbCommand = rconn.CreateCommand


        Cmd.CommandText = "SELECT Max(OligoID) from " & cTableName

        DR = Cmd.ExecuteReader

        If DR.HasRows = True Then
            DR.Read()

            If DR.IsDBNull(0) = True Then
                DBNextOligoID = cDefID
            Else
                DBNextOligoID = DR.GetInt32(0) + 1
            End If
        Else
            DBNextOligoID = cDefID

        End If


        DR.Close()


    End Function


#End Region


    Public Shared Function FieldList() As Collection

        Dim tCollect As New Collection

        tCollect.Add("Gene")
        tCollect.Add("LabName")
        tCollect.Add("RecDate")
        tCollect.Add("FormerName")

        Return tCollect


    End Function





End Class
