
Imports LabDB.DBSaber.StdTools

''' <summary>
''' Represents a yeast database record
''' </summary>
''' <remarks></remarks>
Public Class Yeast



#Region " Member Variables "

    Private m_YeastID As Integer
    Private m_LabName As String = ""
    Private m_RecDate As Date = Now
    Private m_Plasmid As String = ""
    Private m_MatingType As String = ""
    Private m_Donor As String = ""
    Private m_FormerName As String = ""
    Private m_Comments As String
    Private m_Genotype As String = ""
    Private m_LastModified As Date = Now


    Private m_CustomField1 As String = ""
    Private m_CustomField2 As String = ""


#End Region




    Public Const cTableName As String = "tblYeast"




#Region " Construcors "

    Public Sub New()

        'Blank

    End Sub

    Public Sub New(ByRef rConn As Data.Common.DbConnection, ByVal vYeastID As Integer)

        Me.DBLoad(rConn, vYeastID)

    End Sub

    Public Sub New(ByRef rRS As Data.Common.DbDataReader)

        Me.RSLoad(rRS)

    End Sub

#End Region



#Region " Properties "

    Public Property YeastID() As Integer
        Get
            Return Me.m_YeastID
        End Get
        Set(ByVal value As Integer)
            Me.m_YeastID = value
        End Set
    End Property

    Public Property LabName() As String
        Get
            Return Me.m_LabName
        End Get
        Set(ByVal value As String)
            Me.m_LabName = value
        End Set
    End Property

    Public Property RecDate() As Date
        Get
            Return Me.m_RecDate
        End Get
        Set(ByVal value As Date)
            Me.m_RecDate = value
        End Set
    End Property

    Public Property Plasmid() As String
        Get
            Return Me.m_Plasmid
        End Get
        Set(ByVal value As String)
            Me.m_Plasmid = value
        End Set
    End Property

    Public Property FormerName() As String
        Get
            Return Me.m_FormerName
        End Get
        Set(ByVal value As String)
            Me.m_FormerName = value
        End Set
    End Property



    Public Property MatingType() As String
        Get
            Return Me.m_MatingType
        End Get
        Set(ByVal value As String)
            Me.m_MatingType = value
        End Set
    End Property

    Public Property Genotype() As String
        Get
            Return Me.m_Genotype
        End Get
        Set(ByVal value As String)
            Me.m_Genotype = value
        End Set
    End Property

    Public Property Donor() As String
        Get
            Return Me.m_Donor
        End Get
        Set(ByVal value As String)
            Me.m_Donor = value
        End Set
    End Property

    Public Property Comments() As String
        Get
            Return Me.m_Comments
        End Get
        Set(ByVal value As String)
            Me.m_Comments = value
        End Set
    End Property

    Public ReadOnly Property LastModified() As Date
        Get
            Return Me.m_LastModified
        End Get
    End Property

    Public ReadOnly Property FullName() As String
        Get
            Return Me.LabName & "-" & String.Format("{0:00000}", Me.YeastID)
            'Return Me.LabName & "-" & String.Format("{0:000#}", Me.OligoID)
        End Get
    End Property


    Public Property CustomField1() As String
        Get
            Return Me.m_CustomField1
        End Get
        Set(ByVal value As String)
            Me.m_CustomField1 = value
        End Set
    End Property

    Public Property CustomField2() As String
        Get
            Return Me.m_CustomField2
        End Get
        Set(ByVal value As String)
            Me.m_CustomField2 = value
        End Set
    End Property

#End Region


#Region " Database Support "


    Public Sub DBLoad(ByRef rConn As Data.Common.DbConnection, ByVal vYeastID As Integer)

        Dim RS As Data.Common.DbDataReader
        Dim Cmd As Data.Common.DbCommand = rConn.CreateCommand


        Cmd.CommandText = "SELECT * FROM " & cTableName & " WHERE YeastID=@pYeastID"
        CommandParamAdd(Cmd, "pYeastID", DbType.Int32, vYeastID)

        RS = Cmd.ExecuteReader


        If RS.HasRows = True Then
            RS.Read()
            Me.RSLoad(RS)
            RS.Close()
        Else
            'Couldn't find it in the table
            Throw New DBSaber.NoRecordFoundDBException(cTableName, "YeastID", vYeastID)
            RS.Close()
        End If


    End Sub

    Public Sub RSLoad(ByRef rRS As Data.Common.DbDataReader)

        Me.m_YeastID = rRS.GetInt32(0)
        Me.m_LabName = DBValStr(rRS, 1)
        Me.m_RecDate = DBValDate(rRS, 2)
        Me.m_Plasmid = DBValStr(rRS, 3)
        Me.m_MatingType = DBValStr(rRS, 4)
        Me.m_Donor = DBValStr(rRS, 5)
        Me.m_FormerName = DBValStr(rRS, 6)
        Me.m_Comments = DBValStr(rRS, 7)
        Me.m_Genotype = DBValStr(rRS, 8)
        Me.m_CustomField1 = DBValStr(rRS, 9)
        Me.m_CustomField2 = DBValStr(rRS, 10)
        Me.m_LastModified = DBValDate(rRS, 11)

    End Sub

    Public Sub DBSave(ByRef rConn As OleDb.OleDbConnection)


        Dim SQL As String
        'Dim DR As Data.Common.DbDataReader
        Dim Cmd As OleDb.OleDbCommand = rConn.CreateCommand


        If Me.YeastID = 0 Then

            Me.m_LastModified = Now


            'Insert

            SQL = "INSERT INTO " & cTableName & " (LabName, RecDate, Plasmid, MatingType, Donor, FormerName, Comments, Genotype, CustomField1, CustomField2, LastModified) VALUES ("
            SQL = SQL & "@pLabName, @pRecDate, @pPlasmid, @pMatingType, @pDonor, @pFormerName, @pComments, @pGenotype, @pCustomField1, @pCustomField2, @pLastModified)"


            'SQL = SQL & "; " & vbCrLf & " SELECT @@IDENTITY AS NewOligoID"


            Cmd.CommandText = SQL

            CommandParamAdd(Cmd, "pLabName", DbType.String, Me.LabName)
            CommandParamAdd(Cmd, "pRecDate", DbType.String, Me.RecDate)
            CommandParamAdd(Cmd, "pPlasmid", DbType.String, Me.Plasmid)
            CommandParamAdd(Cmd, "pMatingType", DbType.String, Me.MatingType)
            CommandParamAdd(Cmd, "pDonor", DbType.String, Me.Donor)
            CommandParamAdd(Cmd, "pFormerName", DbType.String, Me.FormerName)
            CommandParamAdd(Cmd, "pComments", DbType.String, Me.Comments)
            CommandParamAdd(Cmd, "pGenotype", DbType.String, Me.Genotype)
            CommandParamAdd(Cmd, "pCustomField1", DbType.String, Me.CustomField1)
            CommandParamAdd(Cmd, "pCustomField2", DbType.String, Me.CustomField2)
            CommandParamAdd(Cmd, "pLastModified", DbType.String, Me.m_LastModified)


            Cmd.ExecuteNonQuery()

            'Retrieving the new autonumber
            Me.YeastID = DBSaber.StdTools.DBValue(rConn, "SELECT YeastID FROM " & cTableName & " WHERE LastModified=@pLastModified", "@pLastModified", DbType.String, Me.LastModified)


        Else
            'Update

            Me.m_LastModified = Now

            SQL = "UPDATE " & cTableName & " SET LabName=@pLabName, RecDate=@pRecDate"
            SQL = SQL & ", Plasmid=@pPlasmid, MatingType=@pMatingType, Donor=@pDonor, FormerName=@pFormerName"
            SQL = SQL & ", Comments=@pComments, Genotype=@pGenotype"
            SQL = SQL & ", CustomField1=@pCustomField1, CustomField2=@pCustomField2, LastModified=@pLastModified"
            SQL = SQL & " WHERE YeastID=@pYeastID"


            Cmd.CommandText = SQL


            CommandParamAdd(Cmd, "pLabName", DbType.String, Me.LabName)
            CommandParamAdd(Cmd, "pRecDate", DbType.String, Me.RecDate)
            CommandParamAdd(Cmd, "pPlasmid", DbType.String, Me.Plasmid)
            CommandParamAdd(Cmd, "pMatingType", DbType.String, Me.MatingType)
            CommandParamAdd(Cmd, "pDonor", DbType.String, Me.Donor)
            CommandParamAdd(Cmd, "pFormerName", DbType.String, Me.FormerName)
            CommandParamAdd(Cmd, "pComments", DbType.String, Me.Comments)
            CommandParamAdd(Cmd, "pGenotype", DbType.String, Me.Genotype)
            CommandParamAdd(Cmd, "pCustomField1", DbType.String, Me.CustomField1)
            CommandParamAdd(Cmd, "pCustomField2", DbType.String, Me.CustomField2)
            CommandParamAdd(Cmd, "pLastModified", DbType.String, Me.m_LastModified)

            CommandParamAdd(Cmd, "pYeastID", DbType.String, Me.YeastID)


            Cmd.ExecuteNonQuery()



        End If


    End Sub


    Public Shared Function DBYeasts(ByRef rConn As Data.Common.DbConnection) As Generic.List(Of Yeast)

        Dim Cmd As Data.Common.DbCommand = rConn.CreateCommand
        Dim RS As Data.Common.DbDataReader
        Dim tCollect As New Generic.List(Of Yeast)

        Cmd.CommandText = "SELECT * FROM " & cTableName & " YEAST"


        RS = Cmd.ExecuteReader

        Do While RS.Read
            tCollect.Add(New Yeast(RS))
        Loop

        RS.Close()


        Return tCollect


    End Function


    ''' <summary>
    ''' Returns a list of all the query items
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function DBQItems() As Generic.List(Of SQLQueryItem)

        Dim tCollect As New Generic.List(Of SQLQueryItem)

        tCollect.Add(New SQLQueryItem("Yeast ID", "YeastID", DbType.Int32, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Lab Name", "LabName", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Record Date", "RecDate", DbType.Date, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Plasmid", "Plasmid", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Mating Type", "MatingType", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Donor", "Donor", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Former Name", "FormerName", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Comments", "Comments", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Genotype", "Genotype", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Custom Field 1", "CustomField1", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))
        tCollect.Add(New SQLQueryItem("Custom Field 2", "CustomField2", DbType.String, SQLQueryItem.eOperators.OWild, "", SQLQueryItem.eCatters.CAnd))

        Return tCollect


    End Function

    ''' <summary>
    ''' Removes a record from the database
    ''' </summary>
    ''' <param name="rConn"></param>
    ''' <param name="vYeastID"></param>
    ''' <remarks></remarks>
    Public Shared Sub DBDelete(ByRef rConn As Data.Common.DbConnection, ByVal vYeastID As Integer)

        Dim Cmd As Data.Common.DbCommand = rConn.CreateCommand

        Cmd.CommandText = "DELETE FROM " & cTableName & " WHERE YeastID=@pYeastID"

        CommandParamAdd(Cmd, "pYeastID", DbType.Int32, vYeastID)

        Cmd.ExecuteNonQuery()

    End Sub

    'Purpose:
    Public Shared Function DBNextYeastID(ByRef rconn As Data.Common.DbConnection) As Integer

        Const cDefID = 1
        Dim DR As Data.Common.DbDataReader
        Dim Cmd As Data.Common.DbCommand = rconn.CreateCommand

        Cmd.CommandText = "SELECT Max(YeastID) from " & cTableName

        DR = Cmd.ExecuteReader

        If DR.HasRows = True Then
            DR.Read()
            If DR.IsDBNull(0) = True Then
                DBNextYeastID = cDefID
            Else
                DBNextYeastID = DR.GetInt32(0) + 1
            End If


        Else
            DBNextYeastID = cDefID
        End If

        DR.Close()

    End Function


#End Region


End Class
