''' <summary>
''' Form for showing dna oligo matches
''' </summary>
''' <remarks></remarks>
Public Class frmOligoDNACompare


    Private fDNALookIn As String
    Private fDNASearch As String
    Private fOligo As Oligo
    Private fMode As GenDec.FormMode


#Region " Form Events "


    Private Sub frmDNACompare_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load


        'UFS.FormLoad(Me, GenDec.INIFileName, , 1)


        Me.rtbDNALookIn.Text = fDNALookIn
        Me.rtbDNASearch.Text = fDNASearch


        Me.lblDNALookInLength.Text = fDNALookIn.Length & " base pairs"
        Me.lblDNASearchStringLength.Text = fDNASearch.Length & " base pairs"


        Dim tCollect As New Generic.List(Of DNASearchResult)





        If fMode = GenDec.FormMode.ModeC Then
            tCollect = DNA.DNACompleteSearch(fDNALookIn, fDNASearch)
            Me.Text = "Oligo DNA Bind Compare Compare " & Me.fOligo.FullName

        Else
            Me.Text = "Oligo DNA PCR Compare " & Me.fOligo.FullName
            tCollect = DNA.PCRSearch(fDNALookIn, fDNASearch, DNA.cMatchNormal, 12)
        End If

        'loading up all the search results
        For Each tR As DNASearchResult In tCollect

            Me.LVWLoadItem(tR)

        Next

    End Sub


    Private Sub frmOligoDNACompare_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'UFS.FormSave(Me, GenDec.INIFileName, , 1)

    End Sub

#End Region


    Public Function paDialog(ByVal vDNARef As String, ByRef rOligo As Oligo, ByVal vmode As GenDec.FormMode)

        Me.fMode = vmode

        Me.fOligo = rOligo
        fDNALookIn = vDNARef
        fDNASearch = fOligo.Sequnce

        Me.ShowDialog()


        Return Me.DialogResult

    End Function


#Region " Control Events "


    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click

        Me.Close()

    End Sub


#End Region



#Region " List View Support "


    Private Sub LVWLoadItem(ByRef rMatch As DNASearchResult, Optional ByVal vIndex As Integer = -1, Optional ByVal vSelect As Byte = 0, Optional ByVal vRemItem As Byte = 0)

        Dim tItem As New ListViewItem

        tItem.Tag = rMatch

        tItem.SubItems(0).Text = rMatch.MatchString
        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rMatch.MatchLength))
        'tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rMatch.MatchType))
        If fMode = GenDec.FormMode.ModeD Then
            tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, 1))
            tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, ""))

        Else
            tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rMatch.MatchCount))
            tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, rMatch.MatchIndexes))
        End If


        'tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, Math.Round(DNA.BasicTm(rMatch.MatchString), 2) & ""))

        tItem.SubItems.Add(New ListViewItem.ListViewSubItem(tItem, Math.Round(DNA.GoodTm(rMatch.MatchString, frmNewMain.OligoMOfNaCl, frmNewMain.OligoPerFormamide), 2) & ""))

        Select Case rMatch.MatchType

            Case DNA.cMatchNormal
                tItem.BackColor = Color.LightGreen
            Case DNA.cMatchComp
                tItem.BackColor = Color.LightBlue
            Case DNA.cMatchRev
                tItem.BackColor = Color.LightPink

            Case DNA.cMatchRevComp
                tItem.BackColor = Color.Yellow
        End Select


        GenDec.LVWItemPlace(Me.lvwList, tItem, vIndex, vSelect, vRemItem)


    End Sub



    Private Sub lvwList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvwList.SelectedIndexChanged

        Dim tMatch As DNASearchResult
        Dim tColor As Color
        Dim LText As String = ""


        If Me.lvwList.SelectedItems.Count = 0 Then Exit Sub


        tMatch = Me.lvwList.SelectedItems(0).Tag


        If tMatch.MatchType = DNA.cMatchNormal Then
            tColor = Color.LightGreen
            LText = tMatch.MatchString
        ElseIf tMatch.MatchType = DNA.cMatchRev Then
            tColor = Color.LightPink
            'Need to flip the string to highlight properly
            LText = DNA.DNAReverse(tMatch.MatchString)
        ElseIf tMatch.MatchType = DNA.cMatchComp Then
            tColor = Color.LightBlue
            'need to flip to highlight properly
            LText = DNA.DNAComplement(tMatch.MatchString)
        ElseIf tMatch.MatchType = DNA.cMatchRevComp Then
            tColor = Color.Yellow
            'need to comp reverse
            LText = DNA.DNAComplementReverse(tMatch.MatchString)
        End If


        clsRTFSupport.BackColorSetWhole(Me.rtbDNALookIn, Color.White)
        clsRTFSupport.FindHighlight(Me.rtbDNALookIn, tMatch.MatchString, tColor, False, False)

        clsRTFSupport.BackColorSetWhole(Me.rtbDNASearch, Color.White)
        clsRTFSupport.FindHighlight(Me.rtbDNASearch, LText, tColor, False, False)


    End Sub


#End Region


End Class