


''' <summary>
''' Search input form for olgio dna matching
''' </summary>
''' <remarks></remarks>
Public Class frmOligoDNASearch

    Private tFoundCollect As New Collection
    Private TheirCollect As Collection

    Private fMode As GenDec.FormMode


    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click


        DNA.cMinMatchLength = Me.cbxLength.Text


        'Fixing their string
        Me.txtDNA.Text = DNA.DNASuperFix(Me.txtDNA.Text)


        'Validating
        If Me.txtDNA.Text = "" Then
            MessageBox.Show("Please specify DNA to search for", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtDNA.Focus()
            Exit Sub
        End If

        'THis shouldn't occur anymore because i am superfixing the dna so
        'all invalid characters are removed
        If DNA.DNAIsValid(Me.txtDNA.Text) = False Then
            MessageBox.Show("Please specify Valid DNA", My.Application.Info.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information)
            Me.txtDNA.Focus()
            Exit Sub
        End If


        If fMode = GenDec.FormMode.ModeD Then
            Me.SearchPCR()
        Else
            Me.SearchBind()
        End If


        'Now have the collect for the search list

        'This closes the form
        Me.DialogResult = Windows.Forms.DialogResult.OK


    End Sub


#Region " Form Events "

    Private Sub frmDNATest_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        UFS.FormLoad(Me, GenDec.INIFileName)


        If Me.fMode = GenDec.FormMode.ModeD Then
            Me.Text = "DNA PCR Search"
        Else
            Me.Text = "DNA Bind Search"
        End If


        For counter1 As Integer = 10 To 30
            Me.cbxLength.Items.Add(counter1)
        Next

        Me.cbxLength.Text = 12




    End Sub

    Private Sub frmDNATest_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        UFS.FormSave(Me, GenDec.INIFileName)

    End Sub

    Private Sub frmDNATest_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize


        'Me.txtDNA.Width = Me.Width - Me.txtDNA.Left - Me.txtDNA.Left
        'Me.txtDNA.Height = Me.Height - 100

    End Sub

#End Region


    Public Function paDialog(ByRef rCollect As Collection, ByRef rDNAToLookIn As String, ByVal vMode As GenDec.FormMode) As DialogResult

        'TheirCollect = rCollect

        Me.fMode = vMode


        Me.ShowDialog()


        If Me.DialogResult = Windows.Forms.DialogResult.OK Then
            rCollect = Me.tFoundCollect
            rDNAToLookIn = Me.txtDNA.Text
        End If


        Return Me.DialogResult


    End Function

    ''' <summary>
    ''' search dna for a binding
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub SearchBind()


        Dim SearchSeq As String


        'Going through each record in the database
        For Each tOligo As Oligo In Oligo.DBOligos(frmNewMain.Conn)


            If tOligo.Sequnce.Length >= DNA.cMinMatchLength Then

                'ToDo: fix the dna in the db rather
                tOligo.Sequnce = tOligo.Sequnce.Trim

                'The idea here is to find the maximum match and do a more exhaustive search
                'for all the matches on the dnacompare form.
                For Each tPartialSeq As String In DNA.DNASplitter(tOligo.Sequnce)

                    SearchSeq = tPartialSeq


                    If tOligo.Sequnce <> "" Then
                        'They have a valid sequence

                        If Me.txtDNA.Text.IndexOf(SearchSeq) <> -1 Then
                            'Try to find the sequence
                            tFoundCollect.Add(tOligo)
                            Exit For
                        ElseIf Me.txtDNA.Text.IndexOf(DNA.DNAComplement(SearchSeq)) <> -1 Then
                            'Try complement

                            tFoundCollect.Add(tOligo)
                            Exit For
                        ElseIf Me.txtDNA.Text.IndexOf(DNA.DNAReverse(SearchSeq)) <> -1 Then
                            'Try reverse
                            tFoundCollect.Add(tOligo)
                            Exit For
                        ElseIf Me.txtDNA.Text.IndexOf(DNA.DNAComplementReverse(SearchSeq)) <> -1 Then
                            'Try complement
                            tFoundCollect.Add(tOligo)
                            Exit For

                        Else
                            'Didn't find it

                        End If


                    End If 'tOligo.Sequence <> ""


                Next tPartialSeq


            End If

        Next tOligo

    End Sub



    'The idea here is find the minimum match and move on
    Private Sub SearchPCR()


        Dim SearchSeq As String


        'Going through each record in the database
        For Each tOligo As Oligo In Oligo.DBOligos(frmNewMain.Conn)


            'Data in the database can be not right
            If tOligo.Sequnce.Length >= DNA.cMinMatchLength Then

                'Forward primer
                'Grabing the minimum length FROM THE RIGHT END
                SearchSeq = tOligo.Sequnce.Substring(tOligo.Sequnce.Length - Me.cbxLength.Text, Me.cbxLength.Text)

                If Me.txtDNA.Text.IndexOf(SearchSeq) <> -1 Then
                    'Found the minimum
                    Me.tFoundCollect.Add(tOligo)

                Else
                    'Try to find the reverse complement primer

                    'reverse primer
                    'todo: question for doctor kane aboue which side of the reverse complement
                    SearchSeq = DNA.DNAComplementReverse(tOligo.Sequnce).Substring(0, 12)

                    If Me.txtDNA.Text.IndexOf(SearchSeq) <> -1 Then
                        Me.tFoundCollect.Add(tOligo)
                    End If

                End If




            End If 'tOligo.Sequnce.Length >= DNA.cMinMatchLength


        Next


    End Sub


End Class